/* UNFINISHED/ NO ESTA TERMINADO */
#include <httpd.h>
#include <http_config.h>
#include <apr_buckets.h>
#include <apr_general.h>
#include <apr_lib.h>
#include <http_request.h>
#include <ctype.h>

module AP_MODULE_DECLARE_DATA wasap_module;

typedef struct
{
    int enabled;
} WASapConfig;


enum WASAP_STATE {
	WSP_STATE_NONE=0,
	WSP_STATE_METHOD,
	WSP_STATE_URL,
	WSP_STATE_QUERYSTRING,
	WSP_STATE_HEADERS,
	WSP_STATE_POSTVARS
};


typedef struct
{
    apr_bucket_brigade *bb;
    enum WASAP_STATE state;
} WASapCtx;


static void *CaseFilterInCreateServerConfig(apr_pool_t *p, server_rec *s)
{
	WASapConfig *pConfig = apr_pcalloc(p, sizeof *pConfig);
    	
	pConfig->bEnabled = 0;
	
	return pConfig;
}


static void CaseFilterInInsertFilter(request_rec *r)
{
	WASapConfig *pConfig=ap_get_module_config(r->server->module_config,
						&case_filter_in_module);
	if(!pConfig->bEnabled)
		return;
	
	ap_add_input_filter("WASapInFilter",NULL,r,r->connection);
}


static apr_status WASapInFilter(ap_filter_t *f,
                                apr_bucket_brigade *pbbOut,
                                ap_input_mode_t eMode,
                                apr_read_type_e eBlock,
                                apr_off_t nBytes)
{
	request_rec *r = f->r;
	conn_rec *c = r->connection;
	WASapCtx *ctx;
	apr_status_t ret;
	
	if (!(ctx = f->ctx)) {
		f->ctx = ctx = apr_palloc(r->pool, sizeof *pCtx);
		ctx->bb = apr_brigade_create(r->pool, c->bucket_alloc);
		ctx->state = WSP_STATE_NONE;
	}
	
	
	if (APR_BRIGADE_EMPTY(ctx->bb)) {
		ret = ap_get_brigade(f->next, ctx->bb, eMode, eBlock, nBytes);
		
		if (eMode == AP_MODE_EATCRLF || ret != APR_SUCCESS)
			return ret;
	}
	
	
	while(!APR_BRIGADE_EMPTY(ctx->bb)) {
		apr_bucket *pbktIn = APR_BRIGADE_FIRST(ctx->bb);
		apr_bucket *pbktOut;
		const char *data;
		apr_size_t len;
		char *buf;
		int n;
		
		/* It is tempting to do this...
		 * APR_BUCKET_REMOVE(pB);
		 * APR_BRIGADE_INSERT_TAIL(pbbOut,pB);
		 * and change the case of the bucket data, but that would be wrong
		 * for a file or socket buffer, for example...
		 */
		
        	if (APR_BUCKET_IS_EOS(pbktIn))
        		goto end;
		
		if (pbtIn->type == NULL)
			goto end;
		
		ret=apr_bucket_read(pbktIn, &data, &len, eBlock);
		if(ret != APR_SUCCESS)
			return ret;
		
		/*
		switch(ctx->state) {
			case WSP_STATE_NONE:
				if (ap_get_method(data,len))
		*/			
		/* check for scheme, then change status...
		 * check get vars, then change status
		 * check headers, then change status...
		 * check ..., then change status...
		 */
        	
        	end:
		APR_BUCKET_REMOVE(pbktIn);
		APR_BRIGADE_INSERT_TAIL(pbbOut, pbktIn);
		
	}
	
	return APR_SUCCESS;
}

        
static const char *cmd_WASap(cmd_parms *cmd, void *dummy, int arg)
{
	CaseFilterInConfig *pConfig
	= ap_get_module_config(cmd->server->module_config,
					&case_filter_in_module);
	
	pConfig->enabled=arg;
	
	return NULL;
}

static const command_rec CaseFilterInCmds[] = 
{
	AP_INIT_FLAG("WASap", cmd_WASap, NULL, RSRC_CONF,
			"Run an input case filter on this host"),
	{ NULL }
};


static void CaseFilterInRegisterHooks(apr_pool_t *p)
{
	ap_hook_insert_filter(CaseFilterInInsertFilter, NULL, NULL, 
                          APR_HOOK_MIDDLE);
	ap_register_input_filter("WASap", CaseFilterInFilter, NULL,
                             AP_FTYPE_RESOURCE);
}

module AP_MODULE_DECLARE_DATA wasap_module =
{
	STANDARD20_MODULE_STUFF,
	NULL,
	NULL,
	CaseFilterInCreateServerConfig,
	NULL,
	CaseFilterInCmds,
	CaseFilterInRegisterHooks
};
