#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <httpd.h>

/* 
   this algorithmic table was created with a bitmask for EVERY metacharacter.
   its only flaw is that '/' is defined with the same value as '\'.
   From a security standpoint, this is a moot point, but from a functionality
   standpoint, this COULD be bad... (most likely for sloppy php coders or
   31337 asp c0derZ who use jscript tekneeqz to esc chars (<-none found))
*/

/** \page class_doc Class Check Documentation
 * \section introduction Introduction
 *	Class Check allows one to classify the expected input
 *	by allowing only characters within one of three groups;
 *	alpha, numeric, and metacharacters. The metacharacters 
 *	group is divided into the 32 metacharacters (which are all
 *	printable characters which are not alphanumeric), <P> ie: <BR>
 *	brackets ({}) , minus sign (-) , parentheses (()). </P>
 */

char *chk_name(void)
{
	return("regex");
}

/** \page regex_doc Regex Check Documentation
 *
 * The Regex check will check variable values against a POSIX
 * regular expresion. To see documentation on regular expresions, check out
 * the man page (man 7 regex).
 *
 * \section Configuration
 *
 * WASapMod regex [expression]
 *
 */

void *chk_regex_cfg(pool *p,void *cfg, char *args)
{
	regex_t *rgx,**tmp;
	array_header *ret;
	
	
	if (!cfg) {
		ret = ap_make_array(p,8,sizeof(regex_t **));
		if (!ret)
			return(NULL);
	} else
		ret=cfg;
	
	rgx = ap_pregcomp(p,args,0);
	
	if (!rgx)
		return(ret);
	
	tmp = (regex_t **) ap_push_array(ret);
	if (!tmp)
		return(ret);
	
	*tmp = rgx;
	
	return(ret);
	
}


char *chk_regex(request_rec *r,void *dummy,char *file,char *key,char *val)
{
	array_header *arr;
	const regex_t **regex;
	int i;
	char *ret;
	
	
	if (!dummy)
		return(NULL);
	
	arr = (array_header *)dummy;
	regex = (const regex_t **)arr->elts;
	
	for (i=0; i<arr->nelts; i++) {
		if (ap_regexec(regex[i],val,0,NULL,0) == 0)
			return("Regex Match");
	}
	
	return(NULL);
	
}
